using System;
using System.Drawing;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Reflection;

namespace AttrSample
{
  [AttributeUsage(AttributeTargets.All)]
  public class DeveloperAttribute : System.Attribute
  {
    private string m_name;

    public DeveloperAttribute(string name)
    {
      m_name = name;
    }

    public string Name
    {
      get { return m_name; }
    }
  };


	/// <summary>
	/// Summary description for AttrViewForm.
	/// </summary>
	/// 
  [Developer(" ")]
	public class AttrViewForm : System.Windows.Forms.Form
	{
    private System.Windows.Forms.Button CloseBtn;
    private System.Windows.Forms.Label label1;
    private System.Windows.Forms.TabControl tabControl1;
    private System.Windows.Forms.TabPage AssemblyPage;
    private System.Windows.Forms.TabPage ModulePage;
    private System.Windows.Forms.TabPage ClassPage;
    private System.Windows.Forms.TabPage MethodPage;
    private System.Windows.Forms.TabPage EventPage;
    private System.Windows.Forms.ComboBox ClassesList;
    private System.Windows.Forms.Label label2;
    private System.Windows.Forms.Label label3;
    private System.Windows.Forms.TextBox AssemblyName;
    private System.Windows.Forms.TreeView AssemblyAttributes;
    private System.Windows.Forms.Label label4;
    private System.Windows.Forms.Label label5;
    private System.Windows.Forms.TextBox ModuleName;
    private System.Windows.Forms.TreeView ModuleAttributes;
    private System.Windows.Forms.Label label6;
    private System.Windows.Forms.TreeView ClassAttributes;
    private System.Windows.Forms.Label label9;
    private System.Windows.Forms.Label label10;
    private System.Windows.Forms.ComboBox MethodList;
    private System.Windows.Forms.TreeView MethodAttributes;
    private System.Windows.Forms.Label label11;
    private System.Windows.Forms.ComboBox EventList;
    private System.Windows.Forms.Label label12;
    private System.Windows.Forms.TreeView EventAttributes;
    private System.Windows.Forms.Label label13;
    private System.Windows.Forms.Label label14;
    private System.Windows.Forms.TreeView PropAttributes;
    private System.Windows.Forms.ComboBox PropList;
    private System.Windows.Forms.TabPage PropertyPage;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public AttrViewForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

      //
      //      AttrViewForm   Object
      //
      Type t = typeof(AttrViewForm);
      while (t != null)
      {
        ClassesList.Items.Insert(0, t);
        t = t.BaseType;
      }

      //
      //    
      //
      ClassesList.SelectedIndex = ClassesList.Items.Count - 1;

      //
      //  
      //
      ClassesList_SelectionChangeCommitted(this, null);
    }

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
      this.CloseBtn = new System.Windows.Forms.Button();
      this.label1 = new System.Windows.Forms.Label();
      this.ClassesList = new System.Windows.Forms.ComboBox();
      this.tabControl1 = new System.Windows.Forms.TabControl();
      this.AssemblyPage = new System.Windows.Forms.TabPage();
      this.AssemblyAttributes = new System.Windows.Forms.TreeView();
      this.label3 = new System.Windows.Forms.Label();
      this.AssemblyName = new System.Windows.Forms.TextBox();
      this.label2 = new System.Windows.Forms.Label();
      this.ModulePage = new System.Windows.Forms.TabPage();
      this.ModuleAttributes = new System.Windows.Forms.TreeView();
      this.ModuleName = new System.Windows.Forms.TextBox();
      this.label5 = new System.Windows.Forms.Label();
      this.label4 = new System.Windows.Forms.Label();
      this.ClassPage = new System.Windows.Forms.TabPage();
      this.ClassAttributes = new System.Windows.Forms.TreeView();
      this.label6 = new System.Windows.Forms.Label();
      this.MethodPage = new System.Windows.Forms.TabPage();
      this.MethodAttributes = new System.Windows.Forms.TreeView();
      this.MethodList = new System.Windows.Forms.ComboBox();
      this.label10 = new System.Windows.Forms.Label();
      this.label9 = new System.Windows.Forms.Label();
      this.EventPage = new System.Windows.Forms.TabPage();
      this.EventAttributes = new System.Windows.Forms.TreeView();
      this.label12 = new System.Windows.Forms.Label();
      this.EventList = new System.Windows.Forms.ComboBox();
      this.label11 = new System.Windows.Forms.Label();
      this.PropertyPage = new System.Windows.Forms.TabPage();
      this.PropAttributes = new System.Windows.Forms.TreeView();
      this.label14 = new System.Windows.Forms.Label();
      this.PropList = new System.Windows.Forms.ComboBox();
      this.label13 = new System.Windows.Forms.Label();
      this.tabControl1.SuspendLayout();
      this.AssemblyPage.SuspendLayout();
      this.ModulePage.SuspendLayout();
      this.ClassPage.SuspendLayout();
      this.MethodPage.SuspendLayout();
      this.EventPage.SuspendLayout();
      this.PropertyPage.SuspendLayout();
      this.SuspendLayout();
      // 
      // CloseBtn
      // 
      this.CloseBtn.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right);
      this.CloseBtn.DialogResult = System.Windows.Forms.DialogResult.Cancel;
      this.CloseBtn.FlatStyle = System.Windows.Forms.FlatStyle.System;
      this.CloseBtn.Location = new System.Drawing.Point(416, 416);
      this.CloseBtn.Name = "CloseBtn";
      this.CloseBtn.Size = new System.Drawing.Size(88, 23);
      this.CloseBtn.TabIndex = 9;
      this.CloseBtn.Text = "";
      this.CloseBtn.Click += new System.EventHandler(this.CloseBtn_Click);
      // 
      // label1
      // 
      this.label1.Location = new System.Drawing.Point(8, 8);
      this.label1.Name = "label1";
      this.label1.Size = new System.Drawing.Size(104, 16);
      this.label1.TabIndex = 11;
      this.label1.Text = " :";
      // 
      // ClassesList
      // 
      this.ClassesList.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
        | System.Windows.Forms.AnchorStyles.Right);
      this.ClassesList.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
      this.ClassesList.Location = new System.Drawing.Point(112, 4);
      this.ClassesList.Name = "ClassesList";
      this.ClassesList.Size = new System.Drawing.Size(394, 21);
      this.ClassesList.TabIndex = 13;
      this.ClassesList.SelectionChangeCommitted += new System.EventHandler(this.ClassesList_SelectionChangeCommitted);
      // 
      // tabControl1
      // 
      this.tabControl1.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
        | System.Windows.Forms.AnchorStyles.Left) 
        | System.Windows.Forms.AnchorStyles.Right);
      this.tabControl1.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                                              this.AssemblyPage,
                                                                              this.ModulePage,
                                                                              this.ClassPage,
                                                                              this.MethodPage,
                                                                              this.EventPage,
                                                                              this.PropertyPage});
      this.tabControl1.HotTrack = true;
      this.tabControl1.Location = new System.Drawing.Point(8, 32);
      this.tabControl1.Multiline = true;
      this.tabControl1.Name = "tabControl1";
      this.tabControl1.SelectedIndex = 0;
      this.tabControl1.Size = new System.Drawing.Size(498, 376);
      this.tabControl1.TabIndex = 14;
      // 
      // AssemblyPage
      // 
      this.AssemblyPage.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                                               this.AssemblyAttributes,
                                                                               this.label3,
                                                                               this.AssemblyName,
                                                                               this.label2});
      this.AssemblyPage.Location = new System.Drawing.Point(4, 22);
      this.AssemblyPage.Name = "AssemblyPage";
      this.AssemblyPage.Size = new System.Drawing.Size(490, 350);
      this.AssemblyPage.TabIndex = 0;
      this.AssemblyPage.Text = "";
      // 
      // AssemblyAttributes
      // 
      this.AssemblyAttributes.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
        | System.Windows.Forms.AnchorStyles.Left) 
        | System.Windows.Forms.AnchorStyles.Right);
      this.AssemblyAttributes.ImageIndex = -1;
      this.AssemblyAttributes.Location = new System.Drawing.Point(72, 28);
      this.AssemblyAttributes.Name = "AssemblyAttributes";
      this.AssemblyAttributes.SelectedImageIndex = -1;
      this.AssemblyAttributes.Size = new System.Drawing.Size(416, 320);
      this.AssemblyAttributes.TabIndex = 3;
      // 
      // label3
      // 
      this.label3.Location = new System.Drawing.Point(8, 32);
      this.label3.Name = "label3";
      this.label3.Size = new System.Drawing.Size(60, 16);
      this.label3.TabIndex = 2;
      this.label3.Text = ":";
      // 
      // AssemblyName
      // 
      this.AssemblyName.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
        | System.Windows.Forms.AnchorStyles.Right);
      this.AssemblyName.Location = new System.Drawing.Point(72, 4);
      this.AssemblyName.Name = "AssemblyName";
      this.AssemblyName.ReadOnly = true;
      this.AssemblyName.Size = new System.Drawing.Size(416, 20);
      this.AssemblyName.TabIndex = 1;
      this.AssemblyName.Text = "";
      // 
      // label2
      // 
      this.label2.Location = new System.Drawing.Point(8, 8);
      this.label2.Name = "label2";
      this.label2.Size = new System.Drawing.Size(48, 16);
      this.label2.TabIndex = 0;
      this.label2.Text = ":";
      // 
      // ModulePage
      // 
      this.ModulePage.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                                             this.ModuleAttributes,
                                                                             this.ModuleName,
                                                                             this.label5,
                                                                             this.label4});
      this.ModulePage.Location = new System.Drawing.Point(4, 22);
      this.ModulePage.Name = "ModulePage";
      this.ModulePage.Size = new System.Drawing.Size(490, 350);
      this.ModulePage.TabIndex = 1;
      this.ModulePage.Text = "";
      // 
      // ModuleAttributes
      // 
      this.ModuleAttributes.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
        | System.Windows.Forms.AnchorStyles.Left) 
        | System.Windows.Forms.AnchorStyles.Right);
      this.ModuleAttributes.ImageIndex = -1;
      this.ModuleAttributes.Location = new System.Drawing.Point(72, 28);
      this.ModuleAttributes.Name = "ModuleAttributes";
      this.ModuleAttributes.SelectedImageIndex = -1;
      this.ModuleAttributes.Size = new System.Drawing.Size(416, 320);
      this.ModuleAttributes.TabIndex = 3;
      // 
      // ModuleName
      // 
      this.ModuleName.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
        | System.Windows.Forms.AnchorStyles.Right);
      this.ModuleName.Location = new System.Drawing.Point(72, 4);
      this.ModuleName.Name = "ModuleName";
      this.ModuleName.ReadOnly = true;
      this.ModuleName.Size = new System.Drawing.Size(416, 20);
      this.ModuleName.TabIndex = 2;
      this.ModuleName.Text = "";
      // 
      // label5
      // 
      this.label5.Location = new System.Drawing.Point(8, 32);
      this.label5.Name = "label5";
      this.label5.Size = new System.Drawing.Size(60, 16);
      this.label5.TabIndex = 1;
      this.label5.Text = ":";
      // 
      // label4
      // 
      this.label4.Location = new System.Drawing.Point(8, 8);
      this.label4.Name = "label4";
      this.label4.Size = new System.Drawing.Size(48, 16);
      this.label4.TabIndex = 0;
      this.label4.Text = ":";
      // 
      // ClassPage
      // 
      this.ClassPage.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                                            this.ClassAttributes,
                                                                            this.label6});
      this.ClassPage.Location = new System.Drawing.Point(4, 22);
      this.ClassPage.Name = "ClassPage";
      this.ClassPage.Size = new System.Drawing.Size(490, 350);
      this.ClassPage.TabIndex = 2;
      this.ClassPage.Text = "";
      // 
      // ClassAttributes
      // 
      this.ClassAttributes.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
        | System.Windows.Forms.AnchorStyles.Left) 
        | System.Windows.Forms.AnchorStyles.Right);
      this.ClassAttributes.ImageIndex = -1;
      this.ClassAttributes.Location = new System.Drawing.Point(72, 4);
      this.ClassAttributes.Name = "ClassAttributes";
      this.ClassAttributes.SelectedImageIndex = -1;
      this.ClassAttributes.Size = new System.Drawing.Size(416, 344);
      this.ClassAttributes.TabIndex = 1;
      // 
      // label6
      // 
      this.label6.Location = new System.Drawing.Point(8, 8);
      this.label6.Name = "label6";
      this.label6.Size = new System.Drawing.Size(60, 16);
      this.label6.TabIndex = 0;
      this.label6.Text = ":";
      // 
      // MethodPage
      // 
      this.MethodPage.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                                             this.MethodAttributes,
                                                                             this.MethodList,
                                                                             this.label10,
                                                                             this.label9});
      this.MethodPage.Location = new System.Drawing.Point(4, 22);
      this.MethodPage.Name = "MethodPage";
      this.MethodPage.Size = new System.Drawing.Size(490, 350);
      this.MethodPage.TabIndex = 4;
      this.MethodPage.Text = "";
      // 
      // MethodAttributes
      // 
      this.MethodAttributes.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
        | System.Windows.Forms.AnchorStyles.Left) 
        | System.Windows.Forms.AnchorStyles.Right);
      this.MethodAttributes.ImageIndex = -1;
      this.MethodAttributes.Location = new System.Drawing.Point(72, 28);
      this.MethodAttributes.Name = "MethodAttributes";
      this.MethodAttributes.SelectedImageIndex = -1;
      this.MethodAttributes.Size = new System.Drawing.Size(416, 320);
      this.MethodAttributes.TabIndex = 3;
      // 
      // MethodList
      // 
      this.MethodList.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
        | System.Windows.Forms.AnchorStyles.Right);
      this.MethodList.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
      this.MethodList.Location = new System.Drawing.Point(72, 4);
      this.MethodList.Name = "MethodList";
      this.MethodList.Size = new System.Drawing.Size(416, 21);
      this.MethodList.TabIndex = 2;
      this.MethodList.SelectionChangeCommitted += new System.EventHandler(this.MethodList_SelectionChangeCommitted);
      // 
      // label10
      // 
      this.label10.Location = new System.Drawing.Point(8, 32);
      this.label10.Name = "label10";
      this.label10.Size = new System.Drawing.Size(60, 16);
      this.label10.TabIndex = 1;
      this.label10.Text = ":";
      // 
      // label9
      // 
      this.label9.Location = new System.Drawing.Point(8, 8);
      this.label9.Name = "label9";
      this.label9.Size = new System.Drawing.Size(64, 16);
      this.label9.TabIndex = 0;
      this.label9.Text = ":";
      // 
      // EventPage
      // 
      this.EventPage.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                                            this.EventAttributes,
                                                                            this.label12,
                                                                            this.EventList,
                                                                            this.label11});
      this.EventPage.Location = new System.Drawing.Point(4, 22);
      this.EventPage.Name = "EventPage";
      this.EventPage.Size = new System.Drawing.Size(490, 350);
      this.EventPage.TabIndex = 5;
      this.EventPage.Text = "";
      // 
      // EventAttributes
      // 
      this.EventAttributes.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
        | System.Windows.Forms.AnchorStyles.Left) 
        | System.Windows.Forms.AnchorStyles.Right);
      this.EventAttributes.ImageIndex = -1;
      this.EventAttributes.Location = new System.Drawing.Point(72, 28);
      this.EventAttributes.Name = "EventAttributes";
      this.EventAttributes.SelectedImageIndex = -1;
      this.EventAttributes.Size = new System.Drawing.Size(416, 320);
      this.EventAttributes.TabIndex = 3;
      // 
      // label12
      // 
      this.label12.Location = new System.Drawing.Point(8, 32);
      this.label12.Name = "label12";
      this.label12.Size = new System.Drawing.Size(60, 16);
      this.label12.TabIndex = 2;
      this.label12.Text = ":";
      // 
      // EventList
      // 
      this.EventList.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
        | System.Windows.Forms.AnchorStyles.Right);
      this.EventList.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
      this.EventList.Location = new System.Drawing.Point(72, 4);
      this.EventList.Name = "EventList";
      this.EventList.Size = new System.Drawing.Size(416, 21);
      this.EventList.TabIndex = 1;
      this.EventList.SelectionChangeCommitted += new System.EventHandler(this.EventList_SelectionChangeCommitted);
      // 
      // label11
      // 
      this.label11.Location = new System.Drawing.Point(8, 8);
      this.label11.Name = "label11";
      this.label11.Size = new System.Drawing.Size(60, 16);
      this.label11.TabIndex = 0;
      this.label11.Text = "  :";
      // 
      // PropertyPage
      // 
      this.PropertyPage.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                                               this.PropAttributes,
                                                                               this.label14,
                                                                               this.PropList,
                                                                               this.label13});
      this.PropertyPage.Location = new System.Drawing.Point(4, 22);
      this.PropertyPage.Name = "PropertyPage";
      this.PropertyPage.Size = new System.Drawing.Size(490, 350);
      this.PropertyPage.TabIndex = 7;
      this.PropertyPage.Text = "";
      // 
      // PropAttributes
      // 
      this.PropAttributes.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
        | System.Windows.Forms.AnchorStyles.Left) 
        | System.Windows.Forms.AnchorStyles.Right);
      this.PropAttributes.ImageIndex = -1;
      this.PropAttributes.Location = new System.Drawing.Point(72, 28);
      this.PropAttributes.Name = "PropAttributes";
      this.PropAttributes.SelectedImageIndex = -1;
      this.PropAttributes.Size = new System.Drawing.Size(416, 320);
      this.PropAttributes.TabIndex = 3;
      // 
      // label14
      // 
      this.label14.Location = new System.Drawing.Point(8, 32);
      this.label14.Name = "label14";
      this.label14.Size = new System.Drawing.Size(60, 16);
      this.label14.TabIndex = 2;
      this.label14.Text = ":";
      // 
      // PropList
      // 
      this.PropList.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
        | System.Windows.Forms.AnchorStyles.Right);
      this.PropList.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
      this.PropList.Location = new System.Drawing.Point(72, 4);
      this.PropList.Name = "PropList";
      this.PropList.Size = new System.Drawing.Size(416, 21);
      this.PropList.TabIndex = 1;
      this.PropList.SelectionChangeCommitted += new System.EventHandler(this.PropList_SelectionChangeCommitted);
      // 
      // label13
      // 
      this.label13.Location = new System.Drawing.Point(8, 8);
      this.label13.Name = "label13";
      this.label13.Size = new System.Drawing.Size(60, 16);
      this.label13.TabIndex = 0;
      this.label13.Text = "  :";
      // 
      // AttrViewForm
      // 
      this.AcceptButton = this.CloseBtn;
      this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
      this.CancelButton = this.CloseBtn;
      this.ClientSize = new System.Drawing.Size(512, 451);
      this.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                                  this.tabControl1,
                                                                  this.ClassesList,
                                                                  this.label1,
                                                                  this.CloseBtn});
      this.MaximizeBox = false;
      this.MinimizeBox = false;
      this.MinimumSize = new System.Drawing.Size(520, 480);
      this.Name = "AttrViewForm";
      this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Show;
      this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
      this.Text = "  ";
      this.tabControl1.ResumeLayout(false);
      this.AssemblyPage.ResumeLayout(false);
      this.ModulePage.ResumeLayout(false);
      this.ClassPage.ResumeLayout(false);
      this.MethodPage.ResumeLayout(false);
      this.EventPage.ResumeLayout(false);
      this.PropertyPage.ResumeLayout(false);
      this.ResumeLayout(false);

    }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main()
		{
			Application.Run(new AttrViewForm());
		}

    #region  

    //
    //    
    //
    private void UpdateAssemblyInfo()
    {
      Type t = (Type)ClassesList.SelectedItem;
      Assembly a = t.Assembly;

      AssemblyName.Text = a.FullName;

      FillAttributesTree(AssemblyAttributes, a.GetCustomAttributes(false));
    }

    //
    //    
    //
    private void UpdateModuleInfo()
    {
      Type t = (Type)ClassesList.SelectedItem;
      Module m = t.Module;

      ModuleName.Text = m.FullyQualifiedName;

      FillAttributesTree(ModuleAttributes, m.GetCustomAttributes(false));
    }

    //
    //    
    //
    private void UpdateClassInfo()
    {
      Type t = (Type)ClassesList.SelectedItem;
      FillAttributesTree(ClassAttributes, t.GetCustomAttributes(false));
    }

    //
    //    
    //
    private void UpdateMethodInfo()
    {
      Type t = (Type)ClassesList.SelectedItem;
      MethodInfo[] methods = t.GetMethods();
      if (FillMethodInfo(t, methods, MethodList, MethodAttributes))
        MethodList_SelectionChangeCommitted(this, null);
    }

    //
    //    
    //
    private void UpdateEventInfo()
    {
      Type t = (Type)ClassesList.SelectedItem;
      EventInfo[] events = t.GetEvents();
      if (FillMethodInfo(t, events, EventList, EventAttributes))
        EventList_SelectionChangeCommitted(this, null);
    }

    //
    //    
    //
    private void UpdatePropInfo()
    {
      Type t = (Type)ClassesList.SelectedItem;
      PropertyInfo[] props = t.GetProperties();
      if (FillMethodInfo(t, props, PropList, PropAttributes))
        PropList_SelectionChangeCommitted(this, null);
    }

    //
    // 
    //
    private void FillAttributesTree(TreeView treeView, object[] attrs)
    {
      treeView.BeginUpdate();

      treeView.Nodes.Clear();

      foreach(object i in attrs) 
      {
        TreeNode node = treeView.Nodes.Add(i.ToString());
        node.ForeColor = Color.DarkBlue;
        Type at = i.GetType();
        foreach(PropertyInfo k in at.GetProperties(BindingFlags.Instance | BindingFlags.Public | BindingFlags.NonPublic))
        {
          string str = k.ToString();
          object obj = k.GetValue(i, null);
          if (obj != null)
            str +=  " = " + obj.ToString();

          node.Nodes.Add(str);
        }
      }

      treeView.ExpandAll();

      treeView.EndUpdate();
    }

    private bool FillMethodInfo(Type t, object[] info, ComboBox list, TreeView tree)
    {
      list.BeginUpdate();
      tree.BeginUpdate();

      list.Items.Clear();
      tree.Nodes.Clear();

      foreach(object i in info) 
      {
        list.Items.Add(i);
      }

      if (list.Items.Count > 0)
      {
        list.Enabled = true;
        tree.Enabled = true;

        list.SelectedIndex = 0;
      }
      else 
      {
        list.Enabled = false;
        tree.Enabled = false;
      }

      list.EndUpdate();
      tree.EndUpdate();

      return tree.Enabled;
    }
    #endregion

    #region  

    //
    //  
    //
    private void CloseBtn_Click(object sender, System.EventArgs e)
    {
      Application.Exit();
    }

    private void ClassesList_SelectionChangeCommitted(object sender, System.EventArgs e)
    {
      UpdateAssemblyInfo();
      UpdateModuleInfo();
      UpdateClassInfo();
      UpdateMethodInfo();
      UpdateEventInfo();
      UpdatePropInfo();
    }

    private void MethodList_SelectionChangeCommitted(object sender, System.EventArgs e)
    {
      MethodInfo mi = (MethodInfo)MethodList.SelectedItem;
      FillAttributesTree(MethodAttributes, mi.GetCustomAttributes(false));
    }

    private void EventList_SelectionChangeCommitted(object sender, System.EventArgs e)
    {
      EventInfo ei = (EventInfo)EventList.SelectedItem;
      FillAttributesTree(EventAttributes, ei.GetCustomAttributes(false));
    }

    private void PropList_SelectionChangeCommitted(object sender, System.EventArgs e)
    {
      PropertyInfo pi = (PropertyInfo)PropList.SelectedItem;
      FillAttributesTree(PropAttributes, pi.GetCustomAttributes(false));
    }
    #endregion
  }
}
